// *** MARS+ LANDER ***
// By Giuseppe Mignogna 
// Version 0.96 - 11.2019
// >> TO BE COMPLETED! <<

#include <stdio.h>
#include <stdlib.h>
#include <peekpoke.h>
#include <cbm.h>
#include "sprite.h"

#define BITMAP_START 0x2000
#define SPRITES_BITMAP 0x1400		// 0x3CC0 0x3A40
#define PARAM_PROCEDURE 0xD0		// 208
#define PARAM_VALUE_1 0xD1			
#define PARAM_VALUE_2 0xD2		
#define PARAM_VALUE_3 0xD3		
#define PARAM_VALUE_4 0xD4
#define DECIMALS 5
#define VERT_THRUST 6
#define HORIZ_THRUST 1
#define MAX_ASTEROIDS 4
#define MAX_PIXELS 30
#define MAX_SHIPS 3
#define KEYBOARD 0xC6
#define KC_CURS_UP 43
#define KC_CURS_DOWN 40
#define KC_CURS_LEFT 48
#define KC_CURS_RIGHT 51
#define KC_SPACE 60
#define KC_RUNSTOP 63
#define KC_ESC 52
#define KC_NULL 64

struct Sprite {
	UCHAR mode;
	UINT x;
	UINT y;
	UINT xo;
	UINT yo;	
	int vx;
	int vy;
	UCHAR xblks;
	UCHAR yblks;
	UCHAR spn;
};

struct Pixel {
	UINT x;
	UCHAR y;
	int vx;
	int vy;
};

struct Sprite g_asteroids[MAX_ASTEROIDS];
struct Pixel g_explosion[MAX_PIXELS];
UCHAR g_coll = 0;
UINT g_xb[320];
UINT g_yb[200];
UCHAR g_bt[8];

void draw_sprite(UCHAR mode, UINT x, UINT y, UCHAR xblks, UCHAR yblks, UCHAR spn) {
	static UINT draw_start = 0;
	static UINT sprite_ptr = 0;
	static UINT loc_1 = 0;
	static UINT loc_2 = 0;
	static UINT c = 0;
	static UCHAR v = 0;
	static UCHAR shift_r = 0;
	static UCHAR shift_l = 0;
	static UCHAR ymod = 0;
	static UCHAR ymod_1 = 0;
	static UCHAR xn = 0;
	static UCHAR yn = 0;
	static UCHAR vl_1 = 0;
	static UCHAR vl_2 = 0;

	// todo: controlli su x, y
	
	// spn = spn * xblks;
	ymod = y & 7; // y % 8;
	shift_r = x & 7;
	shift_l = 8 - shift_r;	
	draw_start = (UINT)(BITMAP_START + x - shift_r + ymod + y/8*320); // int(y/8) * 320
	
	for(yn=0; yn<yblks; yn++) {
		for(xn=0; xn<xblks; xn++) {
			ymod_1 = ymod;
			sprite_ptr = SPRITES_BITMAP + (xn+spn)*8 + yn*320;
			loc_1 = draw_start + xn*8 + yn*320;;
			loc_2 = loc_1 + 8;
			for(c=sprite_ptr; c<(sprite_ptr+8); c++) {
				v = PEEK(c);
				vl_1 = PEEK(loc_1);
				vl_2 = PEEK(loc_2);

				if(mode) {
					if((v >> shift_r & vl_1) || (v << shift_l & vl_2)) {
						g_coll = 1;
					} 
				}

				POKE(loc_1, v >> shift_r ^ vl_1);
				POKE(loc_2, v << shift_l ^ vl_2);
				
				++loc_1;
				++loc_2;				
				++ymod_1;
				
				if(ymod_1 > 7) {
					loc_1 = loc_1 + 312;
					loc_2 = loc_1 + 8;					
					ymod_1 = 0;
				}
			}
		}
	}
}

void play_sound(UCHAR voice, UINT freq, UCHAR on) {
	if(voice == 3) {
		if(on) {
			POKE(65295, (UCHAR)(freq & 255));
			POKE(65296, (PEEK(65296) & 252) | (UCHAR)(freq >> 8));
			POKE(65297, PEEK(65297) | 64);
		} else {
			POKE(65297, PEEK(65297) & 191);
		}
	}
}

void draw_byte(UCHAR xcol, UCHAR ycoord, UCHAR byte) {
	POKE(BITMAP_START + xcol*8 + (ycoord & 7) + ycoord/8*320, byte);
}

void draw_block(UCHAR xcol_beg, UCHAR ycoord_beg, UCHAR xcol_end, UCHAR ycoord_end, UCHAR byte) {
	UCHAR x, y;
	
	for(y=ycoord_beg; y<=ycoord_end; y++) {
		for(x=xcol_beg; x<=xcol_end; x++) {
			draw_byte(x, y, byte);
		}
	}
}

void init_draw_pixel() {
	UINT i;
	
	for(i=0; i<200; i++) g_yb[i] = BITMAP_START + i/8*320;
	for(i=0; i<320; i++) g_xb[i] = i/8 * 8;  // i/8 = int
	for(i=0; i<8; i++) g_bt[i] = 1 << (7 - i);
}

void draw_pixel(UCHAR mode, UINT x, UCHAR y) {
	UINT b = 0;
	
	if(x > 319 || y > 199) return;
	b = g_yb[y] + g_xb[x] + (UCHAR)(y&7);
	// if (mode) POKE(b, PEEK(b) ^ g_bt[x&7]);
	POKE(b, PEEK(b) ^ g_bt[x&7]);
}

UCHAR read_pixel(UINT x, UCHAR y) {
	UINT b = 0;
	
	// if(x > 319 || y > 199) return;
	b = g_yb[y] + g_xb[x] + (UCHAR)(y&7);
	return(PEEK(b) & g_bt[x&7]);
}

void init_sprites_bitmap() {
	const UCHAR data[192] = {
		// 0...95
		0,3,4,8,17,45,36,46,			// 0a: ship motors off
		0,192,32,176,216,220,156,60,	// 1b: ship motors off
		0,3,4,8,17,45,36,46,			// 2a: ship vert motor
		0,192,32,176,216,220,156,60,	// 3b: ship vert motor
		0,3,4,8,17,45,36,238,			// 4a: ship left motor
		0,192,32,176,216,220,156,60,	// 5b: ship left motor
		0,3,4,8,17,45,36,46,			// 6a: ship right motor
		0,192,32,176,216,220,156,63,	// 7b: ship right motor
		0,0,0,8,28,8,0,0,				// 8a: asteroid s
		0,0,24,44,60,24,0,0,			// 9b: asteroid m
		0,0,60,102,78,78,60,0,			// 10a: asteroid l
		60,102,131,147,153,227,70,60,	// 11b: asteroid xl
		
		
		// 96...191
		63,33,38,8,8,15,0,0,
		252,132,100,48,48,240,0,0,
		63,33,38,8,8,15,10,10,
		252,132,100,48,48,240,208,208,
		63,225,38,8,8,15,0,0,
		252,132,100,48,48,240,0,0,
		63,33,38,8,8,15,0,0,
		252,135,100,48,48,240,0,0,
		0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0
	};

	UCHAR i = 0;
	UINT sp = SPRITES_BITMAP;
	
	for(i=0; i<192; i++) {
		POKE(sp, data[i]);
		++sp;

		if(i == 95) sp = SPRITES_BITMAP + 320;
	}
}

void draw_title_screen() {
	UINT x,y;
	UCHAR nx, ny;
	
	draw_sprite(0, 0, 0, 2, 2, 0);
	
	for(nx=0; nx<2; nx++) {
		for(ny=0; ny<2; ny++) {
			for(y=0; y<16; y++) {
				for(x=0; x<64; x++) {
					if (read_pixel(0+x, 0+y)) {
						draw_pixel(1, 32+x*4+nx, 32+y*4+ny);
					}
				}
			}
		}
	}
}

void update_fuel_bar(UCHAR *fuel_h, UCHAR *fuel_l) {
	if(*fuel_h) {
		*fuel_l = *fuel_l << 1;
		// POKE(BITMAP_START + (15 + *fuel_h)*8 + (196 & 7) + 196/8*320, *fuel_l); 
		POKE(BITMAP_START + (15 + *fuel_h)*8 + 7684, *fuel_l); 
		POKE(BITMAP_START + (15 + *fuel_h)*8 + 7685, *fuel_l);

		if (!*fuel_l) {
			--*fuel_h;
			*fuel_l = 255;
		}
	}
}

void init_asteroids(){
	UCHAR i;
	for(i=0; i<MAX_ASTEROIDS; i++) {
		g_asteroids[i].mode = 0;
		g_asteroids[i].x = 0;
		g_asteroids[i].y = 0;
		g_asteroids[i].xo = 0;
		g_asteroids[i].yo = 0;
		g_asteroids[i].vx = 0;
		g_asteroids[i].vy = 0;
		g_asteroids[i].xblks = 1;
		g_asteroids[i].yblks = 1;
		g_asteroids[i].spn = 0;
	}
}

void move_asteroids(){
	static UCHAR i;
	static int delay=0;
	
	for(i=0; i<MAX_ASTEROIDS; i++) {
		if(!g_asteroids[i].vy) {
			if (delay<0) {
				g_asteroids[i].x = rand()%270 + 30;
				g_asteroids[i].y = 5;
				g_asteroids[i].xo = g_asteroids[i].x;
				g_asteroids[i].yo = g_asteroids[i].y;
				g_asteroids[i].vx = rand()%6 - 3;
				g_asteroids[i].vy = rand()%4 + 2;
				g_asteroids[i].spn = rand()%4 + 8;
				draw_sprite(0, g_asteroids[i].x, g_asteroids[i].y, 1, 1, g_asteroids[i].spn);			
				delay = rand()%80 + 10;
			}
		} else {
			g_asteroids[i].x += g_asteroids[i].vx;
			g_asteroids[i].y += g_asteroids[i].vy;
			
			draw_sprite(0, g_asteroids[i].x, g_asteroids[i].y, 1, 1, g_asteroids[i].spn);			
			draw_sprite(0, g_asteroids[i].xo, g_asteroids[i].yo, 1, 1, g_asteroids[i].spn);			

			g_asteroids[i].xo = g_asteroids[i].x;
			g_asteroids[i].yo = g_asteroids[i].y;

			
			if(g_asteroids[i].x < 10 || g_asteroids[i].x > 310 || g_asteroids[i].y > 176) {
				draw_sprite(0, g_asteroids[i].xo, g_asteroids[i].yo, 1, 1, g_asteroids[i].spn);			
				g_asteroids[i].vx = 0;
				g_asteroids[i].vy = 0;
			}
		}
	}

	--delay;
}

void remove_asteroids() {
	UCHAR i;
	
	for(i=0; i<MAX_ASTEROIDS; i++) {
		if(g_asteroids[i].vy) {
			draw_sprite(0, g_asteroids[i].xo, g_asteroids[i].yo, 1, 1, g_asteroids[i].spn);			
			g_asteroids[i].vy = 0;
		}
	}
}

void do_explosion(UINT x_center, UCHAR y_center) {
	UCHAR i, j;
	
	for(i=0; i < MAX_PIXELS; i++) {
		g_explosion[i].x = x_center + rand()%20 - 10;
		g_explosion[i].y = y_center + rand()%20 - 10;
		g_explosion[i].vx = rand()%10 - 5;
		g_explosion[i].vy = rand()%10 - 5;
	}
	
	for(j=0; j < 50; j+=2) {
		for(i=0; i < MAX_PIXELS; i++) {
			draw_pixel(1, g_explosion[i].x, g_explosion[i].y);
		}
		
		play_sound(3, 800 - (UINT)(j<<3), 1);
		
		// waitvsync();
		
		for(i=0; i < MAX_PIXELS; i++) {
			draw_pixel(1, g_explosion[i].x, g_explosion[i].y);
			g_explosion[i].x += g_explosion[i].vx;
			g_explosion[i].y += g_explosion[i].vy;
		}
	}
	
	play_sound(3, 800, 0);
}

int main (void)
{
	int xaf = 0;
	UINT x = 160;
	UINT xf = x << DECIMALS;
	UINT xo = x;
	UINT xpc = x;
	int yaf = 0;	
	UINT y = 16;
	UINT yf = y << DECIMALS;	
	UINT yo = y;	
	UINT ypc = y;

	UCHAR g = 2;
	UCHAR key = KC_NULL;
	UCHAR i = 0, j = 0;
	UCHAR sprn = 0;
	UCHAR sprno = 0;
	UCHAR x_base = 0;
	UCHAR y_base = 0;
	UCHAR fuel_h = 24;
	UCHAR fuel_l = 255;	
	UCHAR ships = 0;
	UCHAR dmg = 0;
	UCHAR exit_status = 0;	
	
	g_coll = 0;
	
	init_sprites_bitmap();
	init_draw_pixel();
	
	// printf("PEEK(PARAM_PROCEDURE) %d\n", PEEK(PARAM_PROCEDURE));
	switch(PEEK(PARAM_PROCEDURE)) {
		case 0:
			// should call play_game(), but we use main() for performance
			ships = PEEK(PARAM_VALUE_1);
			x_base = PEEK(PARAM_VALUE_2);
			y_base = PEEK(PARAM_VALUE_3);
			break;
		case 1:
			draw_title_screen();
			exit_status = 4;	// screen drawn
			break;
	} 
	if(exit_status) return exit_status;
	
	
	// Delete all ships (to avoid xor'ing the left-ships icons)
	draw_block(0, 184, 6, 199, 0);
	// Draws available ships
	for(j=0; j<ships; j++) {
		draw_sprite(0, j*16, 184, 2, 2, 0);	
	}	
	// Draw full fuel bar
	draw_block(16, 196, 39, 197, 255); 
	
	init_asteroids();		
	
	draw_sprite(1, x, y, 2, 2, sprn);
	do {
		key = PEEK(KEYBOARD);
		
		xpc = x;
		ypc = y;
		waitvsync();
		draw_sprite(0, xo, yo, 2, 2, sprno);
		draw_sprite(1, x, y, 2, 2, sprn);
		xo = x;
		yo = y;
		sprno = sprn;

		move_asteroids();
		
		switch(key) {
			case KC_CURS_UP:
				if(fuel_h) {
					yaf = yaf - VERT_THRUST;
					sprn = 2;
					play_sound(3, 600, 1);
					update_fuel_bar(&fuel_h, &fuel_l);
					if(!fuel_h) {	// should be checked outside
						sprn = 0;
						play_sound(3, 0, 0);
					}
				}
				break;
			case KC_CURS_DOWN:
				// ++vy;
				break;
			case KC_CURS_LEFT:
				if(fuel_h) {
					sprn = 6;
					xaf = xaf - HORIZ_THRUST;
					play_sound(3, 800, 1);
					update_fuel_bar(&fuel_h, &fuel_l);
				}
				break;
			case KC_CURS_RIGHT:
				if(fuel_h) {
					sprn = 4;
					xaf = xaf + HORIZ_THRUST;
					play_sound(3, 800, 1);
					update_fuel_bar(&fuel_h, &fuel_l);
				}
				break;
			case KC_NULL:
				sprn = 0;
				play_sound(3, 0, 0);
				break;
		}

		
		xf = xf + xaf;
		x = (xf >> DECIMALS);   

		yaf = yaf + g;
		yf = yf + yaf;
		y = (yf >> DECIMALS);   

		if(y > 170) {
			y = 170;
			yf = (y << DECIMALS);
			yaf = 0;
		} else if(y < 5) {
			y = 5;
			yf = (y << DECIMALS);
			yaf = 0;
		}
		if(x < 5) {
			x = 5;
			xf = (x << DECIMALS);
			xaf = 0;
		} else if(x > 300) {
			x = 300;
			xf = (x << DECIMALS);
			xaf = 0;
		}

		if(g_coll) {
			if (((x+4) > x_base) && ((x+12) < (x_base+12)) && (y_base > (y+12)) && (y_base < (y+16)) && (yaf<20)) {				
				draw_sprite(0, xo, yo, 2, 2, sprno);
				draw_sprite(1, x, y, 2, 2, 0);
				exit_status = 1; // success				
			} else {
				play_sound(3, rand() % 50 + 900, 1);
				POKE(0xFF19, 101);
				waitvsync();
				POKE(0xFF19, 146);
				play_sound(3, 900, 0);

				x = xpc;
				xf = x << DECIMALS;
				y = ypc - 4;
				yf = y << DECIMALS;
				
				g_coll = 0;
				yaf = -yaf; // + g;
				
				if(!fuel_h) dmg = 12; 
				++dmg;
				for(j=0; j<dmg; j++) {
					draw_byte((ships-1)*2, 185+j, 0);
					draw_byte((ships-1)*2+1, 185+j, 0);
				}
				
				if(dmg > 12) {
					draw_sprite(0, xo, yo, 2, 2, sprno);
					do_explosion(x+8, y+8);
					remove_asteroids();
					--ships;
					POKE(PARAM_VALUE_1, ships);
					if(!ships) {
						exit_status = 3;	// game over
					} else {
						exit_status = 2;	// ship exploded
					}
				}
			}
		}		
	} while(key != KC_RUNSTOP && !exit_status);
	
	play_sound(3, 0, 0);
	return exit_status;
}
